diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java b/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java
new file mode 100644
index 000000000..ebf72e971
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java
@@ -0,0 +1,186 @@
+package net.minecraft.core.block.piston;
+
+import org.jetbrains.annotations.NotNull;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.PackedField;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
+/**
+ * NOTE: this class should only be accessed after the Blocks clinit logic is complete, i.e. 
+ * not from within BlockLogic constructors!
+ */
+public abstract class PistonCommon {
+    private PistonCommon() {}
+
+    public static final PackedField DIRECTION   = new PackedField(0, 3);
+    public static final PackedField TYPE        = new PackedField(3, 2);
+    public static final PackedField IS_DETACHED = new PackedField(5, 1);
+    public static final PackedField IS_EXTENDED = new PackedField(6, 1);
+    
+    public static final PackedField NEW_FORMAT_SIGNATURE = new PackedField(7, 1);
+
+    public static final PackedField IS_STICKY   = new PackedField(4, 1);
+    public static final PackedField IS_STEEL    = new PackedField(5, 1);
+
+    public static final PackedField IS_DETACHED_OR_EXTENDED = new PackedField(
+        IS_DETACHED.mask | IS_EXTENDED.mask
+    );
+    
+    public static final PackedField PAIR_COMPARISON = new PackedField(
+        DIRECTION.mask | IS_DETACHED.mask | IS_STEEL.mask
+    );
+
+    // TODO using type id is poorly extensible,
+    // TODO   in the future we should probably just represent piston types with separate Blocks
+    public static final byte TYPE_NORMAL = 0b00;
+    public static final byte TYPE_STICKY = 0b01;
+    public static final byte TYPE_STEEL  = 0b10;
+
+    /**
+     * Event data encodes line length.
+     * @see BlockLogicPistonBase#testLine(World, TilePosc, int)
+     */ 
+    public static final byte EVENT_EXTEND         = 0b00_0; 
+    public static final byte EVENT_RETRACT        = 0b00_1;
+    public static final byte EVENT_DETACH         = 0b01_0;
+    public static final byte EVENT_ATTACH         = 0b01_1;
+    public static final byte EVENT_DETACH_EXTEND  = 0b10_0;
+    public static final byte EVENT_DETACH_RETRACT = 0b10_1;
+
+    public static final @NotNull Block<? extends BlockLogicPistonBase>[] 
+    BASE_BLOCK_MAP = (Block<BlockLogicPistonBase>[]) new Block[] {
+        Blocks.PISTON_BASE,
+        Blocks.PISTON_BASE_STICKY,
+        Blocks.PISTON_BASE_STEEL,
+    };
+    
+    public static final @NotNull Block<? extends BlockLogicPistonHead>[]
+    HEAD_BLOCK_MAP = (Block<BlockLogicPistonHead>[]) new Block[] {
+        Blocks.PISTON_HEAD,
+        Blocks.PISTON_HEAD, // TODO this here is the only reason why we need typeid in block metadata
+        Blocks.PISTON_HEAD_STEEL,
+    };
+
+    public static final int DATA_INVALID = ~0;
+
+    public static int fixLegacyBaseData(@NotNull World world, @NotNull TilePosc basePos) {
+        final var baseBlock = world.getBlockType(basePos);
+        final BlockLogicPistonBase base;
+        assert baseBlock.getLogic() instanceof BlockLogicPistonBase;
+        base = (BlockLogicPistonBase) baseBlock.getLogic();
+        
+        int baseData = world.getBlockData(basePos);
+        if (NEW_FORMAT_SIGNATURE.bool(baseData)) return baseData;
+
+        baseData = TYPE.set(baseData, base.typeId);
+        baseData = NEW_FORMAT_SIGNATURE.set(baseData, 1);
+
+        // Direction bit address is the same as before
+        var baseDir = Direction.fromIdLenient(DIRECTION.get(baseData));
+        
+        // on a healthy world this shouldn't happen
+        if (baseDir == Direction.NONE) return DIRECTION.set(baseData, 0);
+
+        // old data format should not have set those bits
+        if (!IS_DETACHED_OR_EXTENDED.bool(baseData)) set_extended_if_head_matches: {
+            final var headPos = new TilePos(basePos).add(baseDir);
+            final var headBlock = world.getBlockType(headPos);
+            final var headData = world.getBlockData(headPos);
+
+            final boolean isMovingHead = headBlock.getLogic() instanceof BlockLogicPistonMoving;
+
+            if (isMovingHead) {
+                if (!(world.getTileEntity(headPos) instanceof TileEntityMovingPistonBlock moving)) {
+                    break set_extended_if_head_matches;
+                }
+                if (!moving.isSourcePiston) break set_extended_if_head_matches;
+                if (moving.direction != baseDir) break set_extended_if_head_matches;
+            } else if (!(headBlock.getLogic() instanceof BlockLogicPistonHead)) {
+                break set_extended_if_head_matches;
+            } 
+
+            // old head data format should not have set this bit
+            if (IS_DETACHED.bool(headData)) break set_extended_if_head_matches;
+            if (DIRECTION.get(headData) != baseDir.id) break set_extended_if_head_matches;
+
+            if (TYPE.get(headData) != base.typeId) break set_extended_if_head_matches;
+
+            baseData = IS_EXTENDED.set(baseData, 1);
+        }
+
+        world.setBlockData(basePos, baseData);
+        return baseData;
+    }
+
+    public static int validateBaseData(int data, @NotNull BlockLogicPistonBase base) {
+        data = TYPE.set(data, base.typeId);
+        if (DIRECTION.get(data) > 5) data = DIRECTION.set(data, 0);
+        // if (IS_DETACHED.bool(data)) data = IS_EXTENDED.set(data, 1);
+        return data;
+    }
+
+    public static int getValidatedBaseData(@NotNull WorldSource world, @NotNull TilePosc pos, @NotNull BlockLogicPistonBase base) {
+        return validateBaseData(world.getBlockData(pos), base);
+    }
+
+    public static int validateHeadData(int data) {
+        data = IS_EXTENDED.set(data, 0);
+        if (DIRECTION.get(data) > 5) data = DIRECTION.set(data, 0);
+        return data;
+    }
+    
+    public static int getValidatedHeadData(@NotNull WorldSource world, @NotNull TilePosc pos) {
+        return validateHeadData(world.getBlockData(pos));
+    }
+
+    public static int baseGetHead(int bdata, @NotNull TilePos hpos, @NotNull World world, @NotNull TilePosc bpos) {
+        hpos.set(bpos).add(Direction.fromId(DIRECTION.get(bdata)));
+        return (world.getBlockType(hpos).getLogic() instanceof BlockLogicPistonHead)
+            ? getValidatedHeadData(world, hpos)
+            : DATA_INVALID; 
+    }
+
+    public static int headGetBase(int hdata, @NotNull TilePos bpos, @NotNull World world, @NotNull TilePosc hpos) {
+        bpos.set(hpos).sub(Direction.fromId(DIRECTION.get(hdata)));
+        return (world.getBlockType(bpos).getLogic() instanceof BlockLogicPistonBase base)
+            ? getValidatedBaseData(world, bpos, base)
+            : DATA_INVALID; 
+    }
+
+    public static enum MovingType {
+        EXTENDING(true, false),
+        EXTENDING_PISTON(true, true),
+        RETRACTING(false, false),
+        RETRACTING_PISTON(false, true);
+
+        private MovingType(boolean isExtending, boolean isSourcePiston) {
+            this.isExtending = isExtending;
+            this.isSourcePiston = isSourcePiston;
+        }
+
+        public final boolean isExtending;
+        public final boolean isSourcePiston;
+    }
+
+    public static @NotNull ItemStack baseItem(int type, boolean isExteneded, boolean isDetached) {
+        int data = 0;
+        data |= TYPE.set(data, type);
+        data |= IS_EXTENDED.set(data, isExteneded ? 1 : 0);
+        data |= IS_DETACHED.set(data, isDetached ? 1 : 0);
+        return new ItemStack(BASE_BLOCK_MAP[type], 1, data);
+    }
+
+    public static @NotNull ItemStack headItem(int type, boolean isDetached) {
+        int data = 0;
+        data |= TYPE.set(data, type);
+        data |= IS_DETACHED.set(data, isDetached ? 1 : 0);
+        return new ItemStack(BASE_BLOCK_MAP[type], 1, data);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 0b7d5745b..8822b3578 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -3,217 +3,210 @@ package net.minecraft.core.block.piston;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Direction;
 import com.mojang.nbt.tags.CompoundTag;
-import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
 import java.util.*;
+import static net.minecraft.core.block.piston.PistonCommon.*;
 
 public class TileEntityMovingPistonBlock extends TileEntity
 {
     public static final int TICKS_TO_EXTEND = 2;
-    private static final List<Entity> entityBuffer = new ArrayList<>();
-
-    private @NotNull Block<?> movedBlock;
-    private int movedData;
-    private @Nullable TileEntity movedEntity;
-    private Direction direction;
-    private boolean extending;
-    private boolean isSourcePiston;
-    private float progress;
-    private float progressO;
-
-    @SuppressWarnings("unused")
-    public TileEntityMovingPistonBlock()
-    {
-    }
-
-    public TileEntityMovingPistonBlock(final @NotNull Block<?> movedBlock, int movedData, @Nullable TileEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
-    {
-        this.movedBlock = movedBlock;
-        this.movedData = movedData;
-        this.movedEntity = movedEntity;
+    private static final float PROGRESS_DELTA = 1f / TICKS_TO_EXTEND;
+
+    @NotNull Block<?> movingBlock;
+    int movingBlockData;
+    @Nullable TileEntity movingTileEntity;
+
+    @NotNull Direction direction;
+    boolean isExtending;
+    boolean isSourcePiston;
+    float progressCur = 0F, progressPrev = 0F;
+
+    // these would otherwise be reallocated each tick, might as well store them here
+    @NotNull AABBd collision = new AABBd(); 
+    @NotNull AABBd bounds = new AABBd();
+
+    
+    public @NotNull Block<?> movingBlock() { return this.movingBlock; }
+    public int movingBlockData() { return this.movingBlockData; }
+    public @Nullable TileEntity movingTileEntity() { return this.movingTileEntity; }
+    
+    public @NotNull Direction direction() { return this.direction; }
+    public @NotNull Direction movingDirection() {
+        return (this.isExtending) ? this.direction : this.direction.opposite();
+    }
+
+    public boolean isExtending() { return this.isExtending; }
+    public boolean isSourcePiston() { return this.isSourcePiston; }
+
+    public @NotNull AABBdc collision() { return this.collision; }
+    public @NotNull AABBdc bounds() { return this.bounds; }
+
+
+    // @SuppressWarnings("unused")
+    public TileEntityMovingPistonBlock() {}
+
+    public TileEntityMovingPistonBlock(
+        @NotNull MovingType type,
+        @NotNull Block<?> movingBlock, int movingData, @Nullable TileEntity movingEntity, 
+        @NotNull Direction direction
+    ) {
+        assert movingBlock != Blocks.PISTON_MOVING;
+        this.movingBlock = movingBlock;
+        this.movingBlockData = movingData;
+        this.movingTileEntity = movingEntity;
         this.direction = direction;
-        this.extending = extending;
-        this.isSourcePiston = isSourcePiston;
-        this.progress = this.progressO = 0.0F;
+        this.isExtending = type.isExtending;
+        this.isSourcePiston = type.isSourcePiston;
     }
 
-    public @NotNull Block<?> getMovedBlock()
-    {
-        return this.movedBlock;
-    }
+    private final void initAABBs() {
+        double dx,dy,dz;
+        final var sign = (this.isExtending) ? -1 : 1;
+        dx = sign * this.direction.offsetX();
+        dy = sign * this.direction.offsetY();
+        dz = sign * this.direction.offsetZ();
 
-	public int getMovedData()
-    {
-        return this.movedData;
-    }
+        this.bounds
+            .set(this.movingBlock.getBoundsFromState(this.worldObj, tilePos))
+            .translate(dx, dy, dz);
 
-    public @Nullable TileEntity getMovedEntity() {
-        return this.movedEntity;
-    }
+        var collision = this.movingBlock.getCollisionAABB(this.worldObj, this.tilePos);
+        if (collision == null) collision = new AABBd(0,0,0,0,0,0);
 
-    public boolean isExtending()
-    {
-        return this.extending;
+        this.collision
+            .set(collision)
+            .translate(dx, dy, dz);
     }
 
-    public Direction getDirection()
-    {
-        return this.direction;
+    private final void translateAABBs(float scale) {
+        final float dx,dy,dz;
+        scale = (this.isExtending) ? scale : -scale;
+        dx = scale * this.direction.offsetX();
+        dy = scale * this.direction.offsetY();
+        dz = scale * this.direction.offsetZ();
+        this.bounds.translate(dx, dy, dz);
+        this.collision.translate(dx, dy, dz);
     }
 
-    public boolean isSourcePiston()
-    {
-        return this.isSourcePiston;
+    @Override
+    public void tick() {
+        this.progressPrev = this.progressCur;
+        if (this.progressCur == 0.0f) this.initAABBs();
+        if (this.progressCur > (1.0F - 0x1p-12F)) {
+            this.finalTick();
+        } else {
+            this.progressCur += PROGRESS_DELTA;
+            this.translateAABBs(PROGRESS_DELTA);
+            this.moveCollidedEntities(PROGRESS_DELTA + 0x1p-7F); 
+        }
     }
 
-    public float getProgress(float partialTick)
-    {
-        if(partialTick > 1.0F)
-        {
-            partialTick = 1.0F;
+    private final void moveCollidedEntities(float scale) {
+        assert this.worldObj != null;
+
+        final var dir = this.movingDirection();
+        final float dx,dy,dz;
+        dx = dir.offsetX() * scale;
+        dy = dir.offsetY() * scale;
+        dz = dir.offsetZ() * scale;
+
+        final int axis = dir.id >> 1; // y z x
+        final boolean neg = (dir.id & 1) == 0;
+        final double lim = 0x1p-4;
+
+        final var entities = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, this.collision);
+        for (final @NotNull var e : entities) {
+            if (e.noPhysics) continue;
+            e.move(dx, dy, dz);
+            switch (axis) {
+                case 2 -> e.xd = (neg) ? Math.min(e.xd, -lim) : Math.max(e.xd, lim);
+                case 0 -> e.yd = (neg) ? Math.min(e.yd, -lim) : Math.max(e.yd, lim);
+                case 1 -> e.zd = (neg) ? Math.min(e.zd, -lim) : Math.max(e.zd, lim);
+            }
         }
-        return this.progressO + (this.progress - this.progressO) * partialTick;
     }
 
-    public float getXOff(float partialTick)
-    {
-        if(this.extending)
-        {
-            return (getProgress(partialTick) - 1.0F) * (float) this.direction.getOffsetX();
-        } else
-        {
-            return (1.0F - getProgress(partialTick)) * (float) this.direction.getOffsetX();
-        }
+    public float progress(float partialTick) {
+        partialTick = Math.min(partialTick, 1.0F);
+        return this.progressPrev + (this.progressCur - this.progressPrev) * partialTick;
     }
 
-    public float getYOff(float partialTick)
-    {
-        if(this.extending)
-        {
-            return (getProgress(partialTick) - 1.0F) * (float) this.direction.getOffsetY();
-        } else
-        {
-            return (1.0F - getProgress(partialTick)) * (float) this.direction.getOffsetY();
-        }
+    public float progressSigned(float partialTick) {
+        final var p = this.progress(partialTick);
+        return (this.isExtending)
+        ? p - 1.0F
+        : 1.0F - p;
     }
 
-    public float getZOff(float partialTick)
-    {
-        if(this.extending)
-        {
-            return (getProgress(partialTick) - 1.0F) * (float) this.direction.getOffsetZ();
-        } else
-        {
-            return (1.0F - getProgress(partialTick)) * (float) this.direction.getOffsetZ();
-        }
+    public float xOffset(float partialTick) {
+        return this.progressSigned(partialTick) * (float) this.direction.offsetX();
     }
 
-    private void moveCollidedEntities(float stretch, float force) {
-        assert this.worldObj != null;
-        if(!this.extending) {
-            stretch--;
-        } else {
-            stretch = 1.0F - stretch;
-        }
-        AABBdc aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z), this.movedBlock, stretch, this.direction);
-        if (aabb == null) return;
-
-        List<Entity> list = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
-        if(!list.isEmpty())
-        {
-            entityBuffer.addAll(list);
-            for (Entity entity : entityBuffer) {
-                if (entity == null || entity.noPhysics) continue;
-                entity.move(force * (float) this.direction.getOffsetX(), force * (float) this.direction.getOffsetY(), force * (float) this.direction.getOffsetZ());
-            }
-            entityBuffer.clear();
-        }
+    public float yOffset(float partialTick) {
+        return this.progressSigned(partialTick) * (float) this.direction.offsetY();
+    }
+    
+    public float zOffset(float partialTick) {
+        return this.progressSigned(partialTick) * (float) this.direction.offsetZ();
     }
 
     public void finalTick() {
-        TilePos selfPos = new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z);
+        final var selfPos = new TilePos(this.tilePos);
         assert this.worldObj != null;
 
-        this.progressO = this.progress = 1.0F;
+        this.progressPrev = this.progressCur = 1.0F;
         this.worldObj.removeTileEntity(selfPos);
         invalidate();
-        if(this.worldObj.getBlockType(selfPos) == Blocks.PISTON_MOVING) {
-            this.worldObj.setBlockTypeDataRaw(selfPos, this.movedBlock, this.movedData);
-            if (this.movedEntity != null) {
-                TileEntity oldEnt = this.worldObj.getTileEntity(selfPos);
-                if (oldEnt != null) {
-                    oldEnt.invalidate();
-                }
-                this.movedEntity.validate();
-                this.movedEntity.tilePos.x = this.tilePos.x;
-                this.movedEntity.tilePos.y = this.tilePos.y;
-                this.movedEntity.tilePos.z = this.tilePos.z;
-                this.worldObj.replaceTileEntity(selfPos, this.movedEntity);
-            }
+        if (this.worldObj.getBlockType(selfPos) != Blocks.PISTON_MOVING) return;
+        this.worldObj.setBlockTypeDataRaw(selfPos, this.movingBlock, this.movingBlockData);
 
-            Block.disableNormalEntityLogic = true;
-            this.movedBlock.onPlacedByWorld(this.worldObj, selfPos);
-            Block.disableNormalEntityLogic = false;
-
-            assert this.movedEntity == null || this.worldObj.getTileEntity(selfPos) == this.movedEntity : "Piston failed to actually move entity!";
-            this.worldObj.notifyBlockChange(selfPos, this.movedBlock);
+        if (this.movingTileEntity != null) {
+            this.movingTileEntity.validate();
+            this.worldObj.replaceTileEntity(selfPos, this.movingTileEntity);
         }
-    }
+        
+        Block.disableNormalEntityLogic = true;
+        this.movingBlock.onPlacedByWorld(this.worldObj, selfPos);
+        Block.disableNormalEntityLogic = false;
 
-    @Override
-	public void tick()
-    {
-        this.progressO = this.progress;
-        if(this.progressO >= 1.0F)
-        {
-            moveCollidedEntities(1.0F, 0.25F);
-            finalTick();
-            return;
-        }
-        this.progress += 1f/TICKS_TO_EXTEND;
-        if(this.progress >= 0.999F)
-        {
-            this.progress = 1.0F;
-        }
-        if(this.extending)
-        {
-            moveCollidedEntities(this.progress, (this.progress - this.progressO) + 0.0625F);
-        }
+        assert this.movingTileEntity == null || this.worldObj.getTileEntity(selfPos) == this.movingTileEntity 
+            : "Piston failed to actually move entity!";
+
+        this.worldObj.notifyBlockChange(selfPos, this.movingBlock);
     }
 
     @Override
     public void readAdditionalData(@NotNull CompoundTag compoundTag) {
-        this.movedBlock = Objects.requireNonNullElse(Blocks.getBlock(compoundTag.getInteger("blockId")), Blocks.AIR);
-        this.movedData = compoundTag.getInteger("blockData");
+        this.movingBlock = Objects.requireNonNullElse(Blocks.getBlock(compoundTag.getInteger("blockId")), Blocks.AIR);
+        this.movingBlockData = compoundTag.getInteger("blockData");
         if (compoundTag.containsKey("tileEntity")) {
             CompoundTag entityTag = compoundTag.getCompound("tileEntity");
-            this.movedEntity = TileEntityDispatcher.createAndLoadEntity(entityTag);
+            this.movingTileEntity = TileEntityDispatcher.createAndLoadEntity(entityTag);
         }
-        this.direction = Direction.getDirectionById(compoundTag.getInteger("facing"));
-        this.progressO = this.progress = compoundTag.getFloat("progress");
-        this.extending = compoundTag.getBoolean("extending");
+        this.direction = Direction.fromId(compoundTag.getInteger("facing"));
+        this.progressPrev = this.progressCur = compoundTag.getFloat("progress");
+        this.isExtending = compoundTag.getBoolean("extending");
     }
 
     @Override
-    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
-    {
-        compoundTag.putInt("blockId", this.movedBlock.id());
-        compoundTag.putInt("blockData", this.movedData);
-        if (this.movedEntity != null) {
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+        compoundTag.putInt("blockId", this.movingBlock.id());
+        compoundTag.putInt("blockData", this.movingBlockData);
+        if (this.movingTileEntity != null) {
             CompoundTag entityTag = new CompoundTag();
-            this.movedEntity.writeToNBT(entityTag);
+            this.movingTileEntity.writeToNBT(entityTag);
             compoundTag.put("tileEntity", entityTag);
         }
-        compoundTag.putInt("facing", this.direction.getId());
-        compoundTag.putFloat("progress", this.progressO);
-        compoundTag.putBoolean("extending", this.extending);
+        compoundTag.putInt("facing", this.direction.id);
+        compoundTag.putFloat("progress", this.progressPrev);
+        compoundTag.putBoolean("extending", this.isExtending);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
index 909a160f3..660fc08ea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
@@ -6,19 +6,14 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
 public interface ISupportable {
     @NotNull ISupport getSupportConstraint(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
     default boolean isSupported(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> supportingBlock = world.getBlockType(tilePos.add(side.getDirection(), new TilePos()));
-        if (supportingBlock == null) {
-            return false;
-        }
-
-        final @NotNull ISupport supporting = supportingBlock.getSupport(world, tilePos.add(side.getDirection(), new TilePos()), side.getOpposite());
+        final @NotNull Block<?> supportingBlock = world.getBlockType(tilePos.add(side.direction(), new TilePos()));
+        final @NotNull ISupport supporting = supportingBlock.getSupport(world, tilePos.add(side.direction(), new TilePos()), side.opposite());
         final @NotNull ISupport supported = this.getSupportConstraint(world, tilePos, side);
-        return supporting.canSupport(supported, side.getOpposite());
+        return supporting.canSupport(supported, side.opposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index 2a8d1432f..5f4b11937 100644
--- a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -178,7 +178,7 @@ public abstract class BlockTags
      */
     public static final Tag<Block<?>> NETHER_MOBS_SPAWN = Tag.of("nether_mobs_spawn");
     /**
-     * Will drop block when piston extends into it
+     * Will drop block when piston push blocks into it
      */
     public static final Tag<Block<?>> PISTON_CRUSHING = Tag.of("piston_crushing");
     /**
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
index a85af8cec..044e534f0 100644
--- a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
@@ -62,11 +62,11 @@ public class BlockState {
 	}
 
 	public boolean hasSignal(World world, TilePosc pos, Direction dir) {
-		return block.isEmittingSignal(world, pos, dir.getSide());
+		return block.isEmittingSignal(world, pos, dir.side());
 	}
 
 	public boolean hasDirectSignal(World world, TilePosc pos, Direction dir) {
-		return block.isEmittingDirectSignal(world, pos, dir.getSide());
+		return block.isEmittingDirectSignal(world, pos, dir.side());
 	}
 
 	public boolean canSurvive(World world, TilePosc pos) {
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/ConduitHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/ConduitHandler.java
index 6db86a5c8..2e53c3f8d 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/ConduitHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/ConduitHandler.java
@@ -89,7 +89,7 @@ public class ConduitHandler {
                 for (Side side : BlockLogicConduit.getOpenSides(data)) {
                     TilePos nPos = new TilePos(pos).add(side);
                     if (world.getBlockType(nPos) == Blocks.CONDUIT &&
-                            BlockLogicConduit.isSideOpen(world.getBlockData(nPos), side.getOpposite())) {
+                            BlockLogicConduit.isSideOpen(world.getBlockData(nPos), side.opposite())) {
                         toSearch.add(nPos);
                     }
                 }
@@ -162,10 +162,8 @@ public class ConduitHandler {
             if (oldPower != newPower) {
                 int state = oldData & BlockLogicConduit.STATE_MASK;
 
-                //suppress recursive neighbor updates while data is being set
-                world.noNeighborUpdate = true;
-                world.setBlockDataNotify(tilePos, (newPower << BlockLogicConduit.POWER_SHIFT) | state);
-                world.noNeighborUpdate = false;
+                world.setBlockData(tilePos, (newPower << BlockLogicConduit.POWER_SHIFT) | state);
+                world.markBlockNeedsUpdate(tilePos);
 
                 //queue updates ONLY for blocks facing the open sides that ARE NOT conduits in this network
                 for (Side side : BlockLogicConduit.getOpenSides(state)) {
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
index ec81ad39e..9565b40a6 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
@@ -808,7 +808,7 @@ public class WireHandler {
             default -> wireSide;
         };
 
-        return wireSide.getOpposite();
+        return wireSide.opposite();
     }
 
     /**
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
index 5c61fc059..efc3de215 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
@@ -53,10 +53,11 @@ public class WorldHelper {
 
         world.setBlockData(pos, metadata);
 
-        // notify clients of the BlockState change
-        world.notifyBlockChange(pos, block);
-        // mark the chunk for saving
-        world.markBlockDirty(pos);
+        // // notify clients of the BlockState change
+        // world.notifyBlockChange(pos, block);
+        world.markBlockNeedsUpdate(pos);
+        // // mark the chunk for saving // is this actually true?
+        // world.markBlockDirty(pos);
 
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index cfaba6e12..0f22991d0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -866,7 +866,7 @@ public abstract class Entity
         double dx = this.x - x;
         double dy = this.y - y;
         double dz = this.z - z;
-        return MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
+        return Math.sqrt(dx * dx + dy * dy + dz * dz);
     }
 
     public double distanceToSqr(@NotNull Entity entity) {
